clear all
close all
clc

%Read in important charachteristics
DX = textread('FNL_DX.txt','%f');
tmp = textread('FNL_FAST.txt','%f');
nnodes = tmp(1);
ypos = tmp(2:end);
dy=zeros(nnodes,1);
for i=1:nnodes-1
    dy(i) = ypos(i+1)-ypos(i);
end



%Read in free surface
[vx_f vy_f vz_f] = textread('vx_vy_f.txt','%f %f %f');
[vx_f_l vy_f_l vz_f_l] = textread('vx_vy_f_left.txt','%f %f %f');
[vx_f_r vy_f_r vz_f_r] = textread('vx_vy_f_right.txt','%f %f %f');

%Read in submerged
[v_x v_y v_z tmp tmp tmp tmp]= textread('FNL_kinematics.txt',' %f %f %f %f %f %f %f');
[v_x_l v_y_l v_z_l tmp tmp tmp tmp]= textread('vx_vy_left.txt', '%f %f %f %f %f %f %f');
[v_x_r v_y_r v_z_r tmp tmp tmp tmp]= textread('vx_vy_right.txt', '%f %f %f %f %f %f %f');




clear tmp;
n = length(v_x);

dudx = zeros(n,1);
dudy = zeros(n,1);
dudz = zeros(n,1);

dvdx = zeros(n,1);
dvdy = zeros(n,1);
dvdz = zeros(n,1);

dwdx = zeros(n,1);
dwdy = zeros(n,1);
dwdz = zeros(n,1);

dudx = (v_x_r-v_x_l)./(2*DX);
dwdx = (v_z_r-v_x_l)./(2*DX);
teller = 0;
for i = 1:n   
teller = teller+1;

if v_x(i) ~= 0.0 && v_z(i) ~=0.0
if teller == 1
    dudz(i) = (v_x(i+1)- v_x(i))/dy(teller);
    dwdz(i) = (v_z(i+1)-v_z(i))/dy(teller);

elseif teller == nnodes
    dudz(i) = (v_x(i)- v_x(i-1))/dy(teller-1);
    dwdz(i) = (v_z(i)-v_z(i-1))/dy(teller-1);
else
    dudz(i) = (v_x(i+1)- v_x(i-1))/(dy(teller)+dy(teller-1));
    dwdz(i) = (v_z(i+1)-v_z(i-1))/(dy(teller)+dy(teller-1));

end
end

if teller == nnodes
    teller = 0;
end
end

dlmwrite('FNL_extra.txt',[dudx dudy dudz dvdx dvdy dvdz dwdx dwdy dwdz],'delimiter','\t','precision','%8.6E');
dlmwrite('FNL_f.txt',[vx_f vy_f vz_f],'delimiter','\t','precision','%8.6E');
    